diff --git a/Tmain/list-pseudo-tags.d/exit-expected.txt b/Tmain/list-pseudo-tags.d/exit-expected.txt
new file mode 100644
index 0000000000..573541ac97
--- /dev/null
+++ b/Tmain/list-pseudo-tags.d/exit-expected.txt
@@ -0,0 +1 @@
+0
diff --git a/Tmain/list-pseudo-tags.d/run.sh b/Tmain/list-pseudo-tags.d/run.sh
new file mode 100644
index 0000000000..4544b3a06a
--- /dev/null
+++ b/Tmain/list-pseudo-tags.d/run.sh
@@ -0,0 +1,8 @@
+# Copyright: 2016 Masatake YAMATO
+# License: GPL-2
+
+CTAGS=$1
+
+${CTAGS} --quiet --options=NONE --list-pseudo-tags | grep -v ENCODING
+
+
diff --git a/Tmain/list-pseudo-tags.d/stderr-expected.txt b/Tmain/list-pseudo-tags.d/stderr-expected.txt
new file mode 100644
index 0000000000..e69de29bb2
diff --git a/Tmain/list-pseudo-tags.d/stdout-expected.txt b/Tmain/list-pseudo-tags.d/stdout-expected.txt
new file mode 100644
index 0000000000..666a77ff74
--- /dev/null
+++ b/Tmain/list-pseudo-tags.d/stdout-expected.txt
@@ -0,0 +1,6 @@
+TAG_FILE_FORMAT	the version of tags file format	on
+TAG_FILE_SORTED	how tags are sorted	on
+TAG_PROGRAM_AUTHOR	the author of this ctags implementation	on
+TAG_PROGRAM_NAME	the name of this ctags implementation	on
+TAG_PROGRAM_URL	the official site URL of this ctags implementation	on
+TAG_PROGRAM_VERSION	the version of this ctags implementation	on
diff --git a/Units/xcmd-coffeetags-pseudo.d/expected.tags b/Units/xcmd-coffeetags-pseudo.d/expected.tags
new file mode 100644
index 0000000000..7c0a5a5f65
--- /dev/null
+++ b/Units/xcmd-coffeetags-pseudo.d/expected.tags
@@ -0,0 +1,3 @@
+!_TAG_PROGRAM_AUTHOR!CoffeeScript	Łukasz Korecki	/lukasz@coffeesounds.com/
+!_TAG_PROGRAM_NAME!CoffeeScript	CoffeeTags	//
+!_TAG_PROGRAM_URL!CoffeeScript	https://github.com/lukaszkorecki/CoffeeTags	/GitHub repository/
diff --git a/Units/xcmd-coffeetags-pseudo.d/features b/Units/xcmd-coffeetags-pseudo.d/features
new file mode 100644
index 0000000000..d9fb0a5e3f
--- /dev/null
+++ b/Units/xcmd-coffeetags-pseudo.d/features
@@ -0,0 +1 @@
+coproc
diff --git a/Units/xcmd-coffeetags-pseudo.d/filter b/Units/xcmd-coffeetags-pseudo.d/filter
new file mode 100644
index 0000000000..f0bc592633
--- /dev/null
+++ b/Units/xcmd-coffeetags-pseudo.d/filter
@@ -0,0 +1,2 @@
+#!/bin/sh
+grep -v '!_TAG_PROGRAM_VERSION'
diff --git a/Units/xcmd-coffeetags-pseudo.d/input.coffee b/Units/xcmd-coffeetags-pseudo.d/input.coffee
new file mode 100644
index 0000000000..4fa4fe176d
--- /dev/null
+++ b/Units/xcmd-coffeetags-pseudo.d/input.coffee
@@ -0,0 +1,2 @@
+# NOTHING HERE
+
diff --git a/Units/xcmd-coffeetags-pseudo.d/languages b/Units/xcmd-coffeetags-pseudo.d/languages
new file mode 100644
index 0000000000..8cfb151091
--- /dev/null
+++ b/Units/xcmd-coffeetags-pseudo.d/languages
@@ -0,0 +1 @@
+CoffeeScript
diff --git a/docs/news.rst b/docs/news.rst
index 34f4cac8c0..2479dbbd55 100644
--- a/docs/news.rst
+++ b/docs/news.rst
@@ -188,7 +188,8 @@ Following extra tag entries are newly introduced.
 
 ``--list-...`` options
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-``--list-extras``, ``--list-features`` and ``--list-fields`` are added.
+``--list-extras``, ``--list-features``, ``--list-fields``, and
+``--list-pseudo-tags`` are added.
 
 ``--put-field-prefix`` options
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
diff --git a/main/entry.c b/main/entry.c
index 8b94e455da..271fa65edb 100644
--- a/main/entry.c
+++ b/main/entry.c
@@ -37,13 +37,13 @@
 #endif
 
 #include "debug.h"
-#include "ctags.h"
 #include "entry.h"
 #include "field.h"
 #include "fmt.h"
 #include "kind.h"
 #include "main.h"
 #include "options.h"
+#include "ptag.h"
 #include "read.h"
 #include "routines.h"
 #include "sort.h"
@@ -143,58 +143,36 @@ static void rememberMaxLengths (const size_t nameLength, const size_t lineLength
 		TagFile.max.line = lineLength;
 }
 
-extern void writePseudoTag (
-		const char *const tagName,
-		const char *const fileName,
-		const char *const pattern,
-		const char *const language)
+extern void writePseudoTag (const struct sPtagDesc *desc,
+			    const char *const fileName,
+			    const char *const pattern,
+			    const char *const language)
 {
 	const int length = language
+
+#define OPT(X) ((X)?(X):"")
 	  ? fprintf (TagFile.fp, "%s%s%s%s\t%s\t%s\n",
-		     PSEUDO_TAG_PREFIX, tagName,
-		     PSEUDO_TAG_SEPARATOR, language, fileName, pattern)
+		     PSEUDO_TAG_PREFIX, desc->name, PSEUDO_TAG_SEPARATOR, language,
+		     OPT(fileName), OPT(pattern))
 	  : fprintf (TagFile.fp, "%s%s\t%s\t/%s/\n",
-		     PSEUDO_TAG_PREFIX, tagName, fileName, pattern);
+		     PSEUDO_TAG_PREFIX, desc->name,
+		     OPT(fileName), OPT(pattern));
+#undef OPT
 
 	abort_if_ferror (TagFile.fp);
 
 	++TagFile.numTags.added;
-	rememberMaxLengths (strlen (tagName), (size_t) length);
+	rememberMaxLengths (strlen (desc->name), (size_t) length);
 }
 
 static void addPseudoTags (void)
 {
-	if (! Option.xref)
-	{
-		char format [11];
-		const char *formatComment = "unknown format";
-		const char* repoinfo;
-
-		sprintf (format, "%u", Option.tagFileFormat);
+	int i;
+	if (Option.xref)
+		return;
 
-		if (Option.tagFileFormat == 1)
-			formatComment = "original ctags format";
-		else if (Option.tagFileFormat == 2)
-			formatComment =
-				"extended format; --format=1 will not append ;\" to lines";
-
-		writePseudoTag ("TAG_FILE_FORMAT", format, formatComment, NULL);
-		writePseudoTag ("TAG_FILE_SORTED",
-			Option.sorted == SO_FOLDSORTED ? "2" :
-			(Option.sorted == SO_SORTED ? "1" : "0"),
-			"0=unsorted, 1=sorted, 2=foldcase",
-			NULL);
-		writePseudoTag ("TAG_PROGRAM_AUTHOR",  AUTHOR_NAME,  "", NULL);
-		writePseudoTag ("TAG_PROGRAM_NAME",    PROGRAM_NAME, "Derived from Exuberant Ctags", NULL);
-		writePseudoTag ("TAG_PROGRAM_URL",     PROGRAM_URL,  "official site", NULL);
-		repoinfo = ctags_repoinfo? ctags_repoinfo: "";
-		writePseudoTag ("TAG_PROGRAM_VERSION", PROGRAM_VERSION, repoinfo, NULL);
-
-#ifdef HAVE_ICONV
-		if (Option.outputEncoding)
-			writePseudoTag ("TAG_FILE_ENCODING", Option.outputEncoding, "", NULL);
-#endif
-	}
+	for (i = 0; i < PTAG_COUNT; i++)
+		makePtagIfEnabled (i, NULL);
 }
 
 static void updateSortedFlag (
diff --git a/main/entry.h b/main/entry.h
index 32a43840fa..047f692c08 100644
--- a/main/entry.h
+++ b/main/entry.h
@@ -149,7 +149,8 @@ extern char* makePatternString (const tagEntryInfo *const tag);
 
 
 /* language is optional: can be NULL. */
-extern void writePseudoTag (const char *const tagName,
+struct sPtagDesc;
+extern void writePseudoTag (const struct sPtagDesc *pdesc,
 			    const char *const fileName,
 			    const char *const pattern,
 			    const char *const language);
diff --git a/main/lxcmd.c b/main/lxcmd.c
index b02439e1e0..aaa0b08eff 100644
--- a/main/lxcmd.c
+++ b/main/lxcmd.c
@@ -61,6 +61,7 @@
 #include "main.h"
 #include "options.h"
 #include "parse.h"
+#include "ptag.h"
 #include "read.h"
 #include "routines.h"
 #include "vstring.h"
@@ -68,6 +69,8 @@
 #include "pcoproc.h"
 
 #include "flags.h"
+#include "xtag.h"
+#include "ptag.h"
 
 /*
 *   MACROS
@@ -990,6 +993,7 @@ static boolean makePseudoTagEntryFromTagEntry (tagEntry* entry)
 {
 	const char *tagName, *fileName, *pattern;
 	const size_t prefixLength = strlen (PseudoTagPrefix);
+	ptagType t = PTAG_UNKNOWN;
 
 	tagName = entry->name + prefixLength;
 	fileName = entry->file;
@@ -999,17 +1003,28 @@ static boolean makePseudoTagEntryFromTagEntry (tagEntry* entry)
 		return FALSE;
 	else if (strcmp (tagName, "TAG_FILE_FORMAT") == 0)
 		return FALSE;	/* ??? */
-	else if ((strcmp (tagName, "TAG_PROGRAM_AUTHOR") == 0)
-		 || (strcmp (tagName, "TAG_PROGRAM_NAME") == 0)
-		 || (strcmp (tagName, "TAG_PROGRAM_URL") == 0)
-		 || (strcmp (tagName, "TAG_PROGRAM_VERSION") == 0))
+	else if (strcmp (tagName, "TAG_PROGRAM_AUTHOR") == 0)
+		t = PTAG_PROGRAM_AUTHOR;
+	else if (strcmp (tagName, "TAG_PROGRAM_NAME") == 0)
+		t = PTAG_PROGRAM_NAME;
+	else if (strcmp (tagName, "TAG_PROGRAM_URL") == 0)
+		t = PTAG_PROGRAM_URL;
+	else if (strcmp (tagName, "TAG_PROGRAM_VERSION") == 0)
+		t = PTAG_PROGRAM_VERSION;
+
+	if (t == PTAG_UNKNOWN)
+		return FALSE;
+	else
 	{
-		writePseudoTag (tagName, fileName, pattern,
-				entryLookupField(entry, "language", FALSE));
-		return TRUE;
+		struct ptagXcmdData data = {
+			.fileName = fileName,
+			.pattern  = pattern,
+			.language = entryLookupField(entry,
+						     "language",
+						     FALSE),
+		};
+		return makePtagIfEnabled (t, &data);
 	}
-
-	return FALSE;
 }
 
 static boolean makeTagEntryFromTagEntry (xcmdPath* path, tagEntry* entry)
@@ -1019,14 +1034,11 @@ static boolean makeTagEntryFromTagEntry (xcmdPath* path, tagEntry* entry)
 
 	if (hasPseudoTagPrefix (entry->name))
 	{
-		if  (isDestinationStdout())
-			return FALSE;
-		else if (Option.xref)
-			return FALSE;
-		else if (Option.etags)
+		if  ((! isXtagEnabled (XTAG_PSEUDO_TAGS))
+		     || (Option.xref)
+		     || (Option.etags))
 			return FALSE;
-		else
-			return makePseudoTagEntryFromTagEntry (entry);
+		return makePseudoTagEntryFromTagEntry (entry);
 	}
 
 	memset(&filePosition, 0, sizeof(filePosition));
diff --git a/main/options.c b/main/options.c
index 5f2ce902d1..7760d666a7 100644
--- a/main/options.c
+++ b/main/options.c
@@ -29,6 +29,7 @@
 #define OPTION_WRITE
 #include "options.h"
 #include "parse.h"
+#include "ptag.h"
 #include "routines.h"
 #include "xtag.h"
 
@@ -308,6 +309,8 @@ static optionDescription LongOptionDescription [] = {
  {1,"       Output list of supported languages."},
  {1,"  --list-maps=[language|all]"},
  {1,"       Output list of language mappings."},
+ {0,"  --list-pseudo-tags"},
+ {0,"       Output list of pseudo tags."},
  {1,"  --list-regex-flags"},
  {1,"       Output list of flags which can be used in a regex parser definition."},
  {1,"  --map-<LANG>=[+]map"},
@@ -1531,7 +1534,9 @@ static void processListAliasesOption (
 static void processListExtrasOption (
 		const char *const option, const char *const parameter)
 {
-	printXtags ();
+	int i;
+	for (i = 0; i < XTAG_COUNT; i++)
+		printXtag (i);
 	exit (0);
 }
 
@@ -1594,6 +1599,16 @@ static void processListLanguagesOption (
 	exit (0);
 }
 
+static void processListPseudoTagsOptions (
+		const char *const option __unused__,
+		const char *const parameter __unused__)
+{
+	int i;
+	for (i = 0; i < PTAG_COUNT; i++)
+		printPtag (i);
+	exit (0);
+}
+
 static void processListRegexFlagsOptions (
 		const char *const option __unused__,
 		const char *const parameter __unused__)
@@ -2134,6 +2149,7 @@ static parametricOption ParametricOptions [] = {
 	{ "_list-kinds-full",       processListKindsOption,         TRUE,   STAGE_ANY },
 	{ "list-languages",         processListLanguagesOption,     TRUE,   STAGE_ANY },
 	{ "list-maps",              processListMapsOption,          TRUE,   STAGE_ANY },
+	{ "list-pseudo-tags",       processListPseudoTagsOptions,   TRUE,   STAGE_ANY },
 	{ "list-regex-flags",       processListRegexFlagsOptions,   TRUE,   STAGE_ANY },
 	{ "_list-roles",            processListRolesOptions,        TRUE,   STAGE_ANY },
 	{ "maxdepth",               processMaxRecursionDepthOption, TRUE,   STAGE_ANY },
diff --git a/main/ptag.c b/main/ptag.c
new file mode 100644
index 0000000000..da9315558e
--- /dev/null
+++ b/main/ptag.c
@@ -0,0 +1,199 @@
+/*
+ *
+ *  Copyright (c) 1996-2002, Darren Hiebert
+ *  Copyright (c) 2016, Red Hat, Inc.
+ *  Copyright (c) 2016, Masatake YAMATO
+ *
+ *  Author: Masatake YAMATO <yamato@redhat.com>
+ *
+ *   This source code is released for free distribution under the terms of the
+ *   GNU General Public License version 2 or (at your option) any later version.
+ *
+ */
+
+#include "general.h"  /* must always come first */
+
+#include "ctags.h"
+#include "debug.h"
+#include "options.h"
+#include "ptag.h"
+#include <string.h>
+
+
+static void writePseudoTagForXcmdData (ptagDesc *desc,
+				       struct ptagXcmdData *pdata)
+{
+	writePseudoTag (desc,
+			pdata->fileName,  pdata->pattern, pdata->language);
+}
+
+static boolean ptagMakeFormat (ptagDesc *desc, void *data __unused__)
+{
+	char format [11];
+	const char *formatComment = "unknown format";
+
+	sprintf (format, "%u", Option.tagFileFormat);
+	if (Option.tagFileFormat == 1)
+		formatComment = "original ctags format";
+	else if (Option.tagFileFormat == 2)
+		formatComment =
+			"extended format; --format=1 will not append ;\" to lines";
+	writePseudoTag (desc, format, formatComment, NULL);
+
+	return TRUE;
+}
+
+static boolean ptagMakeHowSorted (ptagDesc *desc, void *data __unused__)
+{
+	writePseudoTag (desc,
+			Option.sorted == SO_FOLDSORTED ? "2" :
+			(Option.sorted == SO_SORTED ? "1" : "0"),
+			"0=unsorted, 1=sorted, 2=foldcase",
+			NULL);
+	return TRUE;
+}
+
+static boolean ptagMakeAuthor (ptagDesc *desc, void *data)
+{
+	struct ptagXcmdData *pdata = data;
+
+	if (pdata)
+		writePseudoTagForXcmdData (desc, data);
+	else
+		writePseudoTag (desc,
+				AUTHOR_NAME,  "", NULL);
+	return TRUE;
+}
+
+static boolean ptagMakeProgName (ptagDesc *desc, void *data)
+{
+	struct ptagXcmdData *pdata = data;
+
+	if (pdata)
+		writePseudoTagForXcmdData (desc, data);
+	else
+		writePseudoTag (desc,
+				PROGRAM_NAME,  "Derived from Exuberant Ctags", NULL);
+	return TRUE;
+}
+
+static boolean ptagMakeProgURL (ptagDesc *desc, void *data)
+{
+	struct ptagXcmdData *pdata = data;
+
+	if (pdata)
+		writePseudoTagForXcmdData (desc, data);
+	else
+		writePseudoTag (desc,
+				PROGRAM_URL, "official site", NULL);
+	return TRUE;
+}
+
+static boolean ptagMakeProgVersion (ptagDesc *desc, void *data __unused__)
+{
+	const char* repoinfo = ctags_repoinfo? ctags_repoinfo: "";
+	writePseudoTag (desc, PROGRAM_VERSION, repoinfo, NULL);
+	return TRUE;
+}
+
+#ifdef HAVE_ICONV
+static boolean ptagMakeFileEncoding (ptagDesc *desc, void *data __unused__)
+{
+	if (! Option.outputEncoding)
+		return FALSE;
+
+	writePseudoTag (desc, Option.outputEncoding, "", NULL);
+	return TRUE;
+}
+#endif
+
+static ptagDesc ptagDescs [] = {
+	{ TRUE, "TAG_FILE_FORMAT",
+	  "the version of tags file format",
+	  ptagMakeFormat },
+	{ TRUE, "TAG_FILE_SORTED",
+	  "how tags are sorted",
+	  ptagMakeHowSorted },
+	{ TRUE, "TAG_PROGRAM_AUTHOR",
+	  "the author of this ctags implementation",
+	  ptagMakeAuthor },
+	{ TRUE, "TAG_PROGRAM_NAME",
+	  "the name of this ctags implementation",
+	  ptagMakeProgName },
+	{ TRUE, "TAG_PROGRAM_URL",
+	  "the official site URL of this ctags implementation",
+	  ptagMakeProgURL },
+	{ TRUE, "TAG_PROGRAM_VERSION",
+	  "the version of this ctags implementation",
+	  ptagMakeProgVersion },
+#ifdef HAVE_ICONV
+	{ TRUE, "TAG_FILE_ENCODING",
+	  "the encoding used in output tags file",
+	  ptagMakeFileEncoding },
+#endif
+};
+
+extern boolean makePtagIfEnabled (ptagType type, void *data)
+{
+	ptagDesc *desc;
+
+	Assert (0 <= type && type < PTAG_COUNT);
+
+	desc = ptagDescs + type;
+	if (desc->enabled)
+		return desc->makeTag (desc, data);
+	else
+		return FALSE;
+}
+
+extern boolean isPtagEnabled (ptagType type)
+{
+	ptagDesc *desc;
+
+	Assert (0 <= type && type < PTAG_COUNT);
+
+	desc = ptagDescs + type;
+	return desc->enabled;
+
+}
+
+extern boolean enablePtag (ptagType type, boolean state)
+{
+	boolean oldstate;
+	ptagDesc *desc;
+
+	Assert (0 <= type && type < PTAG_COUNT);
+
+	desc = ptagDescs + type;
+	oldstate = desc->enabled;
+	desc->enabled = state;
+	return oldstate;
+}
+
+extern ptagDesc* getPtagDesc (ptagType type)
+{
+	if (type == PTAG_UNKNOWN
+	    || type >= PTAG_COUNT)
+		return NULL;
+
+	return ptagDescs + type;
+}
+
+extern ptagType getPtagTypeForName (const char *name)
+{
+	int i;
+
+	Assert (name);
+	for (i = 0; i < PTAG_COUNT; i++)
+		if (strcmp (ptagDescs [i].name, name) == 0)
+			return i;
+	return PTAG_UNKNOWN;
+}
+
+extern void printPtag (ptagType type)
+{
+	printf("%s\t%s\t%s\n",
+	       ptagDescs[type].name,
+	       ptagDescs[type].description? ptagDescs[type].description: "NONE",
+	       ptagDescs[type].enabled? "on": "off");
+}
diff --git a/main/ptag.h b/main/ptag.h
new file mode 100644
index 0000000000..6f92bba4c1
--- /dev/null
+++ b/main/ptag.h
@@ -0,0 +1,51 @@
+/*
+ *
+ *  Copyright (c) 2016, Red Hat, Inc.
+ *  Copyright (c) 2016, Masatake YAMATO
+ *
+ *  Author: Masatake YAMATO <yamato@redhat.com>
+ *
+ *   This source code is released for free distribution under the terms of the
+ *   GNU General Public License version 2 or (at your option) any later version.
+ *
+ */
+#ifndef CTAGS_MAIN_PTAG_H
+#define CTAGS_MAIN_PTAG_H
+
+#include "general.h"
+
+typedef enum ePtagType { /* pseudo tag content control */
+	PTAG_UNKNOWN = -1,
+	PTAG_FILE_FORMAT,
+	PTAG_FILE_SORTED,
+	PTAG_PROGRAM_AUTHOR,
+	PTAG_PROGRAM_NAME,
+	PTAG_PROGRAM_URL,
+	PTAG_PROGRAM_VERSION,
+#ifdef HAVE_ICONV
+	PTAG_FILE_ENCODING,
+#endif
+	PTAG_COUNT
+} ptagType;
+
+typedef struct sPtagDesc {
+	boolean enabled;
+	const char* name;
+	const char* description;  /* displayed in --list-pseudo-tags output */
+	boolean (* makeTag) (struct sPtagDesc *, void *);
+} ptagDesc;
+
+struct ptagXcmdData {
+	const char *fileName;
+	const char *pattern;
+	const char *language;
+};
+
+extern boolean makePtagIfEnabled (ptagType type, void *data);
+extern ptagDesc* getPtagDesc (ptagType type);
+extern ptagType  getPtagTypeForName (const char *name);
+extern void printPtag (ptagType type);
+extern boolean isPtagEnabled (ptagType type);
+extern boolean enablePtag (ptagType type, boolean state);
+
+#endif	/* CTAGS_MAIN_FIELD_H */
diff --git a/main/xtag.c b/main/xtag.c
index 0863d5842b..f3e71814d7 100644
--- a/main/xtag.c
+++ b/main/xtag.c
@@ -55,7 +55,7 @@ extern xtagType  getXtagTypeForOption (char letter)
 	return XTAG_UNKNOWN;
 }
 
-static void printXtag (xtagType i)
+void printXtag (xtagType i)
 {
 	printf("%c\t%s\t%s\n",
 	       xtagDescs[i].letter,
@@ -63,14 +63,6 @@ static void printXtag (xtagType i)
 	       getXtagDesc (i)->enabled? "on": "off");
 }
 
-extern void printXtags (void)
-{
-	int i;
-
-	for (i = 0; i < ARRAY_SIZE (xtagDescs); i++)
-		printXtag (i);
-}
-
 extern boolean isXtagEnabled (xtagType type)
 {
 	xtagDesc* desc = getXtagDesc (type);
diff --git a/main/xtag.h b/main/xtag.h
index 5102a8736a..d2eb796030 100644
--- a/main/xtag.h
+++ b/main/xtag.h
@@ -45,7 +45,7 @@ typedef struct sXtagDesc {
 
 extern xtagDesc* getXtagDesc (xtagType type);
 extern xtagType  getXtagTypeForOption (char letter);
-extern void printXtags (void);
+extern void printXtag (xtagType type);
 extern boolean isXtagEnabled (xtagType type);
 extern boolean enableXtag (xtagType type, boolean state);
 
diff --git a/source.mak b/source.mak
index 91b04f7f48..bdf4087c34 100644
--- a/source.mak
+++ b/source.mak
@@ -27,6 +27,7 @@ MAIN_HEADS =			\
 	main/parse.h		\
 	main/parsers.h		\
 	main/pcoproc.h		\
+	main/ptag.h		\
 	main/read.h		\
 	main/routines.h		\
 	main/selectors.h	\
@@ -54,6 +55,7 @@ MAIN_SRCS =				\
 	main/options.c			\
 	main/parse.c			\
 	main/pcoproc.c			\
+	main/ptag.c			\
 	main/read.c			\
 	main/routines.c			\
 	main/selectors.c		\
diff --git a/win32/ctags_vs2013.vcxproj b/win32/ctags_vs2013.vcxproj
index 8ff768e5f0..7767ab47fb 100644
--- a/win32/ctags_vs2013.vcxproj
+++ b/win32/ctags_vs2013.vcxproj
@@ -148,6 +148,7 @@
     <ClCompile Include="..\parsers\perl.c" />
     <ClCompile Include="..\parsers\perl6.c" />
     <ClCompile Include="..\parsers\php.c" />
+    <ClCompile Include="..\main\ptag.c" />
     <ClCompile Include="..\parsers\python.c" />
     <ClCompile Include="..\main\read.c" />
     <ClCompile Include="..\gnu_regex\regex.c">
@@ -199,6 +200,7 @@
     <ClInclude Include="..\main\options.h" />
     <ClInclude Include="..\main\parse.h" />
     <ClInclude Include="..\main\parsers.h" />
+    <ClInclude Include="..\main\ptag.h" />
     <ClInclude Include="..\main\read.h" />
     <ClInclude Include="..\main\routines.h" />
     <ClInclude Include="..\main\selectors.h" />
diff --git a/win32/ctags_vs2013.vcxproj.filters b/win32/ctags_vs2013.vcxproj.filters
index 487d37b2fb..7685f9026c 100644
--- a/win32/ctags_vs2013.vcxproj.filters
+++ b/win32/ctags_vs2013.vcxproj.filters
@@ -268,6 +268,9 @@
     <ClCompile Include="..\main\repoinfo.c">
       <Filter>Source Files\Main</Filter>
     </ClCompile>
+    <ClCompile Include="..\main\ptag.c">
+      <Filter>Source Files\Main</Filter>
+    </ClCompile>
   </ItemGroup>
   <ItemGroup>
     <ClInclude Include="..\main\e_msoft.h">
@@ -351,5 +354,8 @@
    <ClInclude Include="..\main\xtag.h">
       <Filter>Header Files</Filter>
     </ClInclude>
+   <ClInclude Include="..\main\ptag.h">
+      <Filter>Header Files</Filter>
+    </ClInclude>
   </ItemGroup>
 </Project>
